﻿#coding: utf-8
# 英字の頻度表

from collections import Counter
import matplotlib.pyplot as plt


freq_table = [
        ['A', 8.167], ['B', 1.492], ['C', 2.782], ['D', 4.253],
        ['E', 12.702], ['F', 2.228], ['G', 2.015], ['H', 6.094],
        ['I', 6.966], ['J', 0.153], ['K', 0.772], ['L', 4.025],
        ['M', 2.406], ['N', 6.749], ['O', 7.507], ['P', 1.929],
        ['Q', 0.095], ['R', 5.987], ['S', 6.327], ['T', 9.056],
        ['U', 2.758], ['V', 0.978], ['W', 2.36], ['X', 0.15],
        ['Y', 1.974], ['Z', 0.074]]

obama_speech = (
"MYFELLOWCITIZENSISTANDHERETODAYHUMBL"
"EDBYTHETASKBEFOREUSGRATEFULFORTHETRU"
"STYOUHAVEBESTOWEDMINDFULOFTHESACRIFIC"
"ESBORNEBYOURANCESTORSITHANKPRESIDENTB"
"USHFORHISSERVICETOOURNATIONASWELLASTH"
"EGENEROSITYANDCOOPERATIONHEHASSHOWNTH"
"ROUGHOUTTHISTRANSITIONFORTYFOURAMERIC"
"ANSHAVENOWTAKENTHEPRESIDENTIALOATHTHEW"
"ORDSHAVEBEENSPOKENDURINGRISINGTIDESOFP"
"ROSPERITYANDTHESTILLWATERSOFPEACEYETEV"
"ERYSOOFTENTHEOATHISTAKENAMIDSTGATHERIN"
"GCLOUDSANDRAGINGSTORMSATTHESEMOMENTSAM"
"ERICAHASCARRIEDONNOTSIMPLYBECAUSEOFTHE"
"SKILLORVISIONOFTHOSEINHIGHOFFICEBUTBEC"
"AUSEWETHEPEOPLEHAVEREMAINEDFAITHFULTOT"
"HEIDEALSOFOURFORBEARERSANDTRUETOOURFOU"
"NDINGDOCUMENTSSOITHASBEENSOITMUSTBEWITH"
"THISGENERATIONOFAMERICANSTHATWEAREINTHE"
"MIDSTOFCRISISISNOWWELLUNDERSTOODOURNATI"
"ONISATWARAGAINSTAFARREACHINGNETWORKOFVI"
"OLENCEANDHATREDOURECONOMYISBADLYWEAKENE"
"DACONSEQUENCEOFGREEDANDIRRESPONSIBILITY"
"ONTHEPARTOFSOMEBUTALSOOURCOLLECTIVEFAIL"
"URETOMAKEHARDCHOICESANDPREPARETHENATION"
"FORANEWAGEHOMESHAVEBEENLOSTJOBSSHEDBUSI"
"NESSESSHUTTEREDOURHEALTHCAREISTOOCOSTLY"
"OURSCHOOLSFAILTOOMANYANDEACHDAYBRINGSFUR"
"THEREVIDENCETHATTHEWAYSWEUSEENERGYSTRENG"
"THENOURADVERSARIESANDTHREATENOURPLANETTH"
"ESEARETHEINDICATORSOFCRISISSUBJECTTODATA"
"ANDSTATISTICSLESSMEASURABLEBUTNOLESSPROF"
"OUNDISASAPPINGOFCONFIDENCEACROSSOURLANDA"
"NAGGINGFEARTHATAMERICA’SDECLINEISINEVITA"
"BLEANDTHATTHENEXTGENERATIONMUSTLOWERITSS"
"IGHTS")

encwords = (
"DIJBRCLDIJBRCLCJDDCLKDQFOGIJIGBZLFIOQDV"
"GUQFLUNQTGYLDOLIGFCZKGOJMOCJRLQZJQPGBZJ"
"BDOLKRV")


def show_freq_graph(freq2=None):
    tmp_tf = freq_table[:]
    tmp_tf.sort(key=lambda x: x[1])
    tmp_tf.reverse()
    if freq2:
        freqd = dict(freq2)
        tfreq = [(k, freqd[k]) for k, f in tmp_tf]
        plt.bar([x*2.2 for x in range(len(tmp_tf))],
              [x[1] for x in tmp_tf], 1,
              tick_label=[x[0] for x in tmp_tf])
        plt.bar([x*2.2+1 for x in range(len(tfreq))],
              [x[1] for x in tfreq],
              tick_label=[x[0] for x in tfreq])

    else:
        plt.bar(range(len(tmp_tf)),
              [x[1] for x in tmp_tf],
              tick_label=[x[0] for x in tmp_tf])

def calc_freq_table(text):
    """
    文字(アルファベット大文字)の出現頻度を調べる関数
    """
    flist = list(Counter(text.replace(' ', '')).items())
    length = len(text)
    flist = [(x[0], x[1]/length*100) for x in flist]
    flist.sort(key=lambda x: x[1])
    flist.reverse()
    return flist
